/*
 * @(#)GeneralSecurityException.java	1.4 97/08/07
 * 
 * Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */
 
package com.novell.java.security;

/**
 * Groups all the exception classes of the java.security package that
 * extend from it. Exceptions extending from GeneralSecurityException
 * include AccessControlException and CertificateException, which
 * subclass from java.lang.SecurityException, and ProviderException
 * and InvalidParameterException, which subclass from 
 * java.lang.RuntimeException.
 * 
 * @version 1.4, 98/01/14
 * @author Jan Luehe
 */

public class GeneralSecurityException extends Exception {

    /** 
     * Constructs a GeneralSecurityException with no detail message.  
     */
    public GeneralSecurityException() {
        super();
    }

    /**
     * Constructs a GeneralSecurityException with the specified detail
     * message. A detail message is a String that describes this particular
     * exception.
     *
     * @param msg The detail message.  
     */
    public GeneralSecurityException(String msg) {
        super(msg);
    }
}
