/* **************************************************************************

  $Archive: /njcl/src/com/novell/java/security/AnotherIdentityIsAuthenticatedException.java $
  $Revision: 6 $
  $Modtime: 10/21/98 4:40p $

  Copyright (c) 1997-1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL PROPRIETARY
  AND TRADE SECRET INFORMATION OF NOVELL, INC. ACCESS  TO  THIS  WORK IS
  RESTRICTED TO (I) NOVELL, INC.  EMPLOYEES WHO HAVE A NEED TO  KNOW HOW
  TO  PERFORM  TASKS WITHIN  THE SCOPE  OF  THEIR   ASSIGNMENTS AND (II)
  ENTITIES OTHER  THAN  NOVELL, INC.  WHO  HAVE ENTERED INTO APPROPRIATE
  LICENSE   AGREEMENTS.  NO  PART  OF  THIS WORK MAY BE USED, PRACTICED,
  PERFORMED COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,
  CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED,  RECAST, TRANSFORMED
  OR ADAPTED  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.  ANY USE
  OR EXPLOITATION  OF  THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE
  PERPETRATOR  TO CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/
package com.novell.java.security;

/**
 * Thrown when another identity is authenticated to the resource for
 * which the authentication is requested.
 *
 * @see LoginException
 *
 * @author Jan Sture Nielsen
 * @version 1.0.0
 */
public class AnotherIdentityIsAuthenticatedException extends LoginException
{
   /**
    * Default constructor.
    */
   public AnotherIdentityIsAuthenticatedException()
   {
      super(I2L.getString(XMsg.ANOTHER_IDENTITY_IS_AUTHENTICATED));
   }

   /**
    * Constructor with a String message.
    *
    * @param message message associated with the exception
    */
   public AnotherIdentityIsAuthenticatedException(String message)
   {
      super(message);
   }

   /**
    * Constructor with a String message and a root cause exception.
    *
    * @param message   A message associated with the exception.
    * @param exception The root cause exception.
    */
   public AnotherIdentityIsAuthenticatedException(String message,java.lang.Throwable exception)
   {
      super(message,exception);
   }

   /**
    * Constructor with a root cause exception.
    *
    * @param exception The root cause exception.
    */
   public AnotherIdentityIsAuthenticatedException(java.lang.Throwable exception)
   {
      this(I2L.getString(XMsg.ANOTHER_IDENTITY_IS_AUTHENTICATED),exception);
   }
}
